Index: orxonox/branches/physics/src/Makefile.am
===================================================================
--- orxonox/branches/physics/src/Makefile.am	(revision 3866)
+++ orxonox/branches/physics/src/Makefile.am	(revision 3953)
@@ -17,4 +17,7 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/glmenu
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/animation
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/common
 
 
@@ -30,10 +33,10 @@
 		 command_node.cc \
 		 keynames.cc \
-		 camera.cc \
+		 world_entities/camera.cc \
 		 track_manager.cc \
 		 track_node.cc \
-		 animation.cc \
-		 animation3d.cc \
-		 animation_player.cc \
+		 util/animation/animation.cc \
+		 util/animation/animation3d.cc \
+		 util/animation/animation_player.cc \
 		 garbage_collector.cc \
 		 story_entities/story_entity.cc \
@@ -69,6 +72,6 @@
 		 lib/lang/base_object.cc \
 		 lib/util/ini_parser.cc \
-		 lib/util/list.cc \
-		 lib/util/resource_manager.cc \
+		 util/common/list.cc \
+		 util/resource_manager.cc \
 		 lib/math/vector.cc \
 		 lib/math/curve.cc \
@@ -79,5 +82,5 @@
 		 track_manager.h \
                  ability.h \
-		 camera.h \
+		 world_entities/camera.h \
 		 keynames.h \
 		 command_node.h \
@@ -85,8 +88,8 @@
 		 track_manager.h \
 		 track_node.h \
-		 animation.h \
-		 t_animation.h \
-		 animation3d.h \
-		 animation_player.h \
+		 util/animation/animation.h \
+		 util/animation/t_animation.h \
+		 util/animation/animation3d.h \
+		 util/animation/animation_player.h \
 		 garbage_collector.h \
 		 story_entities/story_entity.h \
@@ -125,7 +128,7 @@
 		 lib/lang/base_entity.h \
 		 lib/lang/base_object.h \
-		 lib/util/list.h \
-		 lib/util/list_template.h \
-		 lib/util/resource_manager.h \
+		 util/common/list.h \
+		 util/common/list_template.h \
+		 util/resource_manager.h \
 		 lib/util/ini_parser.h \
 		 lib/math/vector.h \
Index: orxonox/branches/physics/src/defs/debug.h
===================================================================
--- orxonox/branches/physics/src/defs/debug.h	(revision 3866)
+++ orxonox/branches/physics/src/defs/debug.h	(revision 3953)
@@ -68,7 +68,8 @@
 #define DEBUG_MODULE_LIGHT              0
 #define DEBUG_MODULE_PLAYER             1
+#define DEBUG_MODULE_WEAPON             3
 #define DEBUG_MODULE_MATH               0
-#define DEBUG_MODULE_FONT               4
-#define DEBUG_MODULE_ANIM               3
+#define DEBUG_MODULE_FONT               1
+#define DEBUG_MODULE_ANIM               1
 
 #define DEBUG_MODULE_NULL_PARENT        0
Index: orxonox/branches/physics/src/lib/graphics/importer/Makefile.am
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/Makefile.am	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/Makefile.am	(revision 3953)
@@ -4,7 +4,9 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/story_entities
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/coord
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/util
@@ -15,4 +17,7 @@
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/glmenu
 AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/animation
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/common
 
 
@@ -34,5 +39,8 @@
 		  $(MAINSRCDIR)/lib/lang/base_object.cc \
 		  $(MAINSRCDIR)/lib/math/vector.cc \
-		  $(MAINSRCDIR)/lib/util/resource_manager.cc
+		  $(MAINSRCDIR)/util/resource_manager.cc \
+		  $(MAINSRCDIR)/lib/graphics/text_engine.cc \
+		  $(MAINSRCDIR)/lib/coord/p_node.cc \
+		  $(MAINSRCDIR)/lib/coord/null_parent.cc
 
 noinst_HEADERS= framework.h \
Index: orxonox/branches/physics/src/lib/graphics/importer/material.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/material.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/material.cc	(revision 3953)
@@ -34,9 +34,8 @@
    \param mtlName Name of the Material to be added to the Material List
 */
-Material::Material (char* mtlName)
+Material::Material (const char* mtlName)
 {
    PRINTF(4)("initializing new Material.\n");
-  this->nextMat = NULL;
-  this->name ="";
+  this->name = NULL;
   this->setIllum(3);
   this->setDiffuse(0,0,0);
@@ -55,8 +54,5 @@
   this->specularTextureSet = false;
 
-  if (mtlName)
-    this->setName (mtlName);
-  else
-    this->setName("");
+  this->setName(mtlName);
 }
 
@@ -71,47 +67,4 @@
   if (this->diffuseTexture)
     ResourceManager::getInstance()->unload(this->diffuseTexture);
-  if (this->nextMat)
-    delete this->nextMat;
-}
-
-/**
-   \brief adds a new Material to the List.
-   this Function will append a new Material to the end of a Material List.
-   \param mtlName The name of the Material to be added.
-*/
-Material* Material::addMaterial(char* mtlName)
-{
-  PRINTF(4)("adding Material %s.\n", mtlName);
-   Material* tmpMat = this;
-  while (tmpMat->nextMat != NULL)
-    {
-      tmpMat = tmpMat->nextMat;
-    }
-  tmpMat->nextMat = new Material(mtlName);
-  return tmpMat->nextMat;
-  
-}
-
-/**
-   \brief Search for a Material called mtlName
-   \param mtlName the Name of the Material to search for
-   \returns Material named mtlName if it is found. NULL otherwise.
-*/
-Material* Material::search(char* mtlName)
-{
-  PRINTF(5)("Searching for material %s", mtlName);
-  Material* searcher = this;
-  while (searcher != NULL)
-    {
-      PRINT(5)(".");
-      if (!strcmp (searcher->getName(), mtlName))
-	{
-	  PRINT(5)("found.\n");
-	  return searcher;
-	}
-      searcher = searcher->nextMat;
-    }
-  PRINT(2)("material %s not found\n", mtlName);
-  return NULL;
 }
 
@@ -168,9 +121,18 @@
    \param mtlName the Name of the Material to be set.
 */ 
-void Material::setName (char* mtlName)
-{
-  PRINTF(4)("setting Material Name to %s.\n", this->name);
-  this->name = new char [strlen(mtlName)+1];
-  strcpy(this->name, mtlName);
+void Material::setName (const char* mtlName)
+{
+  if (this->name)
+    delete this->name;
+  if (mtlName)
+    {
+      this->name = new char [strlen(mtlName)+1];
+      strcpy(this->name, mtlName);
+    }
+  else
+    {
+      this->name = new char[2];
+      strcpy(this->name, "");
+    }
 }
 
Index: orxonox/branches/physics/src/lib/graphics/importer/material.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/material.h	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/material.h	(revision 3953)
@@ -14,4 +14,8 @@
 #endif /* HAVE_CONFIG_H */
 
+#ifndef NULL
+#define NULL 0
+#endif
+
 // FORWARD DEFINITIONS //
 class Texture;
@@ -22,12 +26,10 @@
 {
  public:
-  Material (char* mtlName = "");
-  Material* addMaterial(char* mtlName);
+  Material (const char* mtlName = NULL);
   ~Material ();
 
-  Material* search(char* mtlName);
   bool select (void);
 
-  void setName (char* mtlName);
+  void setName (const char* mtlName);
   char* getName (void);
   void setIllum (int illum);
@@ -70,7 +72,4 @@
   bool specularTextureSet;//!< Chekcs if the specular texture is Set.
 
-  Material* nextMat; //!< pointer to the Next Material of the List. NULL if no next exists.
-
-
 };
 #endif
